package org.jboss.cache;

import org.jboss.cache.marshall.MethodCall;
import org.jgroups.Address;

import java.lang.reflect.Method;
import java.util.List;

public interface RPCManager
{
   public List callRemoteMethods(List<Address> recipients, MethodCall methodCall, int mode, boolean excludeSelf, long timeout) throws Exception;

   public boolean isCoordinator();

   public Address getCoordinator();

   public List callRemoteMethods(List<Address> recipients, MethodCall methodCall, boolean synchronous, boolean excludeSelf, int timeout) throws Exception;

   public List callRemoteMethods(List<Address> recipients, Method method, Object[] arguments, boolean synchronous, boolean excludeSelf, long timeout) throws Exception;

   public void setCache(CacheSPI c);

   /**
    * @return Returns the replication queue (if one is used), null otherwise.
    */
   public ReplicationQueue getReplicationQueue();
}
