package performancetests;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import org.apache.log4j.BasicConfigurator;

/**
 * This is a simple shell with three commands
 * active, inactive and Exit.
 * 
 * You don't have to modify this!
 * @author dnielben
 *
 */
public class AWEDTestConsole {
	boolean active = false;
	BufferedReader in = 
		new BufferedReader(new InputStreamReader(System.in));
	
	CachePasiveInstanceForPerformanceTest cchins;
	
	public AWEDTestConsole() {
		super();
	}
	
	public void StatusActive(){
		active = true;
		junit.textui.TestRunner.run(ReplicationPerformanceTest.suite());
	}
	
	public CachePasiveInstanceForPerformanceTest cacheInstance(){
		return new CachePasiveInstanceForPerformanceTest("");
		
	}
	public void StatusInactive(){
		active = false;
	}
	
	public String input(){
		String resp ="";
		try {
			resp = in.readLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return resp;
	}
	
	public void print(String s){
		System.out.println(s);
	}
	
	public void processMessage(String s) throws Exception{
		if(s.equals("exception")) throw new Exception("My exception");
		
	}
	
	public void startConsole() throws Exception{
		while(true){
			String resp = input();
			if(resp.equals("cacheInstance")) cchins = cacheInstance();
			if(resp.equals("active")) StatusActive();
			if(resp.equals("inactive")) StatusInactive();
			if(resp.equals("Exit")){
				try {
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
				System.exit(0);
			}
			processMessage(resp);
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Set up a simple configuration that logs on the console.
	    // BasicConfigurator.configure();
		AWEDTestConsole m = new AWEDTestConsole();
		try {
			m.startConsole();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
