package org.jboss.cache;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * Tests restart (stop-destroy-create-start) of CacheImpl
 *
 * @author Bela Ban
 * @version $Id: TreeNodeTest.java,v 1.6 2007/01/11 13:49:06 msurtani Exp $
 */
public class TreeNodeTest extends TestCase
{
   CacheImpl cache;

   protected void setUp() throws Exception
   {
      super.setUp();
      cache = (CacheImpl) DefaultCacheFactory.getInstance().createCache();
   }

   protected void tearDown() throws Exception
   {
      super.tearDown();
      stopCache(cache);
   }

   public void testChildExist() throws Exception
   {
      Object key = 1;
      cache.put("/a/b/c", key, "test");
      Node node;
      node = cache.get("/a/b");
      assertFalse(node.getChildren().isEmpty());
      assertTrue(node.getChild(new Fqn("c")) != null);

      Fqn fqn = Fqn.fromString("/e/f");
      cache.put(fqn, "1", "1");
      node = cache.get("/e");
      assertFalse(node.getChildren().isEmpty());
      assertTrue(node.getChild(new Fqn("f")) != null);

   }


   void stopCache(CacheImpl c)
   {
      c.stop();
      c.destroy();
   }

   public static Test suite()
   {
      return new TestSuite(TreeNodeTest.class);
   }

   public static void main(String[] args)
   {
      junit.textui.TestRunner.run(suite());
   }

}
