package org.jboss.cache.loader;

import org.jboss.cache.Fqn;

import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * An extension of the {@link org.jboss.cache.loader.DummyInMemoryCacheLoader} that uses static maps for data, children,
 * etc. so it can be shared across instances, emulating a shared database or filesystem cache loader.
 *
 * @author <a href="mailto:manik@jboss.org">Manik Surtani</a>
 * @since 2.0.0
 */
public class DummySharedInMemoryCacheLoader extends DummyInMemoryCacheLoader
{
   protected static final Map<Fqn, DummyNode> SHARED_NODES_MAP = new ConcurrentHashMap<Fqn, DummyNode>();

   public DummySharedInMemoryCacheLoader()
   {
      nodes = SHARED_NODES_MAP;
   }
}
