/*
 * JBoss, the OpenSource J2EE webOS
 * 
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.cache.loader;

import junit.framework.TestCase;

import java.util.Properties;

/**
 * Unit test class for FileCacheLoaderConfig
 *
 * @author <a href="mailto:galder.zamarreno@jboss.com">Galder Zamarreno</a>
 */
public class FileCacheLoaderConfigTest extends TestCase
{
   private FileCacheLoaderConfig fclc;

   protected void setUp() throws Exception
   {
      fclc = new FileCacheLoaderConfig();
   }

   public void testSetProperties()
   {
      fclc.setProperties((Properties)null);
      assertTrue(fclc.isCheckCharacterPortability());
      assertNull(fclc.getLocation());

      Properties p = new Properties();
      p.setProperty("location", "any");
      fclc.setProperties(p);
      assertTrue(fclc.isCheckCharacterPortability());
      assertEquals("any", fclc.getLocation());

      p.clear();

      p.setProperty("check.character.portability", "true");
      fclc.setProperties(p);
      assertTrue(fclc.isCheckCharacterPortability());
      assertNull(fclc.getLocation());

      p.clear();

      p.setProperty("check.character.portability", "false");
      fclc.setProperties(p);
      assertFalse(fclc.isCheckCharacterPortability());
      assertNull(fclc.getLocation());
   }
}
