/*
 * JBoss, the OpenSource J2EE webOS
 * 
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.cache.loader;

import junit.framework.TestCase;

/**
 * Unit test for JDBCCacheLoaderConfigTest
 *
 * @author <a href="mailto:galder.zamarreno@jboss.com">Galder Zamarreno</a>
 */
public class JDBCCacheLoaderConfigTest extends TestCase
{
   private AdjListJDBCCacheLoaderConfig cacheLoaderConfig;

   protected void setUp() throws Exception
   {
      cacheLoaderConfig = new AdjListJDBCCacheLoaderConfig();
   }

   public void testSetGetConnectionFactory()
   {
      cacheLoaderConfig.setConnectionFactoryClass("com.acme.Paradise");
      assertEquals("com.acme.Paradise", cacheLoaderConfig.getConnectionFactoryClass());
   }

   public void testEqualsHashCode()
   {
      cacheLoaderConfig.setConnectionFactoryClass("com.acme.Paradise");
      AdjListJDBCCacheLoaderConfig other = new AdjListJDBCCacheLoaderConfig();
      other.setConnectionFactoryClass("com.acme.Paradise");
      assertTrue(cacheLoaderConfig.equals(other));
      assertEquals(cacheLoaderConfig.hashCode(), other.hashCode());

      other.setConnectionFactoryClass("com.ibm.flaming.Gala");
      assertFalse(cacheLoaderConfig.equals(other));
   }
}
