package org.jboss.cache.loader;

import junit.framework.Test;
import junit.framework.TestSuite;
import org.jboss.cache.misc.TestingUtil;

/**
 * Tests {@link org.jboss.cache.loader.jdbm.JdbmCacheLoader}.
 *
 * @author Elias Ross
 * @version $Id: JdbmCacheLoaderTest.java,v 1.8 2007/05/23 10:28:54 msurtani Exp $
 */
public class JdbmCacheLoaderTest extends CacheLoaderTestsBase
{
   protected void configureCache() throws Exception
   {
      String tmpDir = System.getProperty("java.io.tmpdir", "/tmp");
      String tmpCLLoc = tmpDir + "/JBossCache-FileCacheLoaderTest";
      cache.getConfiguration().setCacheLoaderConfig(getSingleCacheLoaderConfig("", "org.jboss.cache.loader.jdbm.JdbmCacheLoader", "location=" + tmpCLLoc, false, true, false));
      TestingUtil.recursiveFileRemove(tmpCLLoc);
   }

   public static Test suite()
   {
      return new TestSuite(JdbmCacheLoaderTest.class);
   }

   public static void main(String[] args)
   {
      junit.textui.TestRunner.run(suite());
   }

}
