package org.jboss.cache.loader;

import junit.framework.Test;
import junit.framework.TestSuite;
import org.jboss.cache.CacheImpl;
import org.jboss.cache.DefaultCacheFactory;
import org.jboss.cache.config.Configuration;

/**
 * Created by IntelliJ IDEA.
 * User: bela
 * Date: Jun 9, 2004
 * Time: 9:05:19 AM
 */
public class LocalDelegatingCacheLoaderTest extends CacheLoaderTestsBase
{
   CacheImpl delegating_cache;

   protected void configureCache() throws Exception
   {
      delegating_cache = (CacheImpl) DefaultCacheFactory.getInstance().createCache(false);
      delegating_cache.getConfiguration().setCacheMode(Configuration.CacheMode.LOCAL);
      delegating_cache.create();
      delegating_cache.start();

      // setCache first ...
      cache.getConfiguration().setCacheLoaderConfig(getSingleCacheLoaderConfig("", "org.jboss.cache.loader.LocalDelegatingCacheLoader", "", false, false, false));

      // force our own cache loader instance
      LocalDelegatingCacheLoader cacheLoader = new LocalDelegatingCacheLoader(delegating_cache);
      cache.setCacheLoader(cacheLoader);
   }

   protected void tearDown() throws Exception
   {
      super.tearDown();
      delegating_cache.stop();
      delegating_cache.destroy();
   }

   public void testLoadAndStore() throws Exception
   {
      //TODO intentional overload since this test does not pass
      //http://jira.jboss.com/jira/browse/JBCACHE-851
   }

   public void testPartialLoadAndStore()
   {
      // do nothing
   }

   public void testBuddyBackupStore()
   {
      // do nothing
   }

   public void testCacheLoaderThreadSafety()
   {
      // do nothing
   }

   public void testCacheLoaderThreadSafetyMultipleFqns()
   {
      // do nothing
   }


   public static Test suite()
   {
      return new TestSuite(LocalDelegatingCacheLoaderTest.class);
   }


   public static void main(String[] args)
   {
      junit.textui.TestRunner.run(suite());
   }

}
