package org.jboss.cache.loader;

import junit.framework.Test;
import junit.framework.TestSuite;
import org.jboss.cache.loader.tcp.TcpCacheServer;
import org.jboss.cache.misc.TestingUtil;

/**
 * Tests the TcpDelegatingCacheLoader
 *
 * @author Bela Ban
 * @version $Id: TcpCacheLoaderTest.java,v 1.12 2006/12/20 13:40:24 msurtani Exp $
 */
public class TcpCacheLoaderTest extends CacheLoaderTestsBase
{
   static TcpCacheServer cache_server = null;

   static
   {
      Thread runner = new Thread()
      {
         public void run()
         {
            try
            {
               System.out.println("Starting TcpCacheServer");
               cache_server = new TcpCacheServer();
               cache_server.setBindAddress("127.0.0.1");
               cache_server.setPort(12121);
               cache_server.setConfig("META-INF/local-service.xml"); // must be in classpath (./etc/META-INF)
               cache_server.create();
               cache_server.start();
            }
            catch (Exception ex)
            {
               ex.printStackTrace();
            }
         }
      };

      Runtime.getRuntime().addShutdownHook(new Thread()
      {
         public void run()
         {
            if (cache_server != null)
            {
               System.out.println("Stopping TcpCacheServer");
               cache_server.stop();
            }
         }
      });

      runner.start();
   }

   public void testPartialLoadAndStore()
   {
      // do nothing
   }

   public void testBuddyBackupStore()
   {
      // do nothing
   }


   protected void configureCache() throws Exception
   {
      cache.getConfiguration().setCacheLoaderConfig(getSingleCacheLoaderConfig("",
              "org.jboss.cache.loader.TcpDelegatingCacheLoader",
              "host=127.0.0.1\nport=12121", false, true, false));

      // give the tcp cache server time to start up
      TestingUtil.sleepThread(2000);
   }


   public static Test suite()
   {
      return new TestSuite(TcpCacheLoaderTest.class);
   }


   public static void main(String[] args)
   {
      junit.textui.TestRunner.run(suite());
   }

}