/*
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */
package org.jboss.cache.marshall;

import org.jboss.cache.RegionManager;

public class CacheMarshaller200Test extends CacheMarshallerTestBase
{
   public CacheMarshaller200Test()
   {
      currentVersion = "2.0.0.GA";
      currentVersionShort = 20;
      expectedMarshallerClass = CacheMarshaller200.class;
   }

   public void testHandle140Stream() throws Exception
   {
      VersionAwareMarshaller marshallerOld = new VersionAwareMarshaller(new RegionManager(), false, false, "1.4.0.GA");

      // create a '140' stream.

      byte[] buf = marshallerOld.objectToByteBuffer("hello");
      Object unmarshalled = marshaller.objectFromByteBuffer(buf);

      assertEquals("hello", unmarshalled);
   }

}
