package org.jboss.cache.marshall;

import junit.framework.TestCase;
import org.jboss.cache.transaction.GlobalTransaction;

/**
 * @author <a href="mailto:manik@jboss.org">Manik Surtani</a>
 */
public class MethodCallFactoryTest extends TestCase
{
   public void testVarArgsMethod()
   {
      GlobalTransaction gtx = new GlobalTransaction();
      MethodCall c = MethodCallFactory.create(MethodDeclarations.commitMethod, gtx);

      assertEquals(gtx, c.getArgs()[0]);
   }

   public void testObjectArrayMethod()
   {
      GlobalTransaction gtx = new GlobalTransaction();
      MethodCall c = MethodCallFactory.create(MethodDeclarations.commitMethod, new Object[]{gtx});

      assertEquals(gtx, c.getArgs()[0]);
   }

   public void testMultipleArrayElems()
   {
      GlobalTransaction gtx = new GlobalTransaction();
      MethodCall c = MethodCallFactory.create(MethodDeclarations.commitMethod, new Object[]{gtx, gtx, gtx});

      assertEquals(gtx, c.getArgs()[0]);
      assertEquals(gtx, c.getArgs()[1]);
      assertEquals(gtx, c.getArgs()[2]);

      assertEquals(3, c.getArgs().length);
   }

}
