package org.jboss.cache.passivation;

import junit.framework.Test;
import junit.framework.TestSuite;
import org.jboss.cache.CacheImpl;
import org.jboss.cache.DefaultCacheFactory;
import org.jboss.cache.config.Configuration;
import org.jboss.cache.loader.CacheLoader;
import org.jboss.cache.loader.LocalDelegatingCacheLoader;

/**
 * Runs a test against using delegated cache loader
 *
 * @author <a href="mailto:{hmesha@novell.com}">{Hany Mesha}</a>
 * @version $Id: PassivationToLocalDelegatingCacheLoaderTest.java,v 1.12 2007/07/17 17:22:13 msurtani Exp $
 */
public class PassivationToLocalDelegatingCacheLoaderTest extends PassivationTestsBase
{
   CacheImpl delegating_cache;
   CacheLoader cache_loader;


   protected void configureCache() throws Exception
   {
      delegating_cache = (CacheImpl) DefaultCacheFactory.getInstance().createCache(false);
      delegating_cache.getConfiguration().setCacheMode(Configuration.CacheMode.LOCAL);
      delegating_cache.create();
      delegating_cache.start();
      cache_loader = new LocalDelegatingCacheLoader(delegating_cache);
      // setCache first ...
      cache.getConfiguration().setCacheLoaderConfig(getCacheLoaderConfig("", "org.jboss.cache.loader.LocalDelegatingCacheLoader", "", false, false));
      cache.setCacheLoader(cache_loader);
   }

   protected void tearDown() throws Exception
   {
      super.tearDown();
      delegating_cache.stop();
      delegating_cache.destroy();
   }

   public void testLoadAndStore() throws Exception
   {
      //TODO intentional overload since this test does not pass
      //http://jira.jboss.com/jira/browse/JBCACHE-851
   }


   public static Test suite()
   {
      return new TestSuite(PassivationToLocalDelegatingCacheLoaderTest.class);
   }


   public static void main(String[] args)
   {
      junit.textui.TestRunner.run(suite());
   }

}
