package org.jboss.cache.pojo;

import junit.framework.TestCase;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jboss.cache.pojo.test.IdObject;
import org.jboss.cache.pojo.test.ValueObject;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class RecursiveRefTest extends TestCase
{
   private static final String CONFIG_FILENAME = "META-INF/local-service.xml";
   private PojoCache cache;
   Log log = LogFactory.getLog(RecursiveRefTest.class);

   private Map cachedMap;

   public RecursiveRefTest(String name)
   {
      super(name);
   }

   protected void setUp() throws Exception
   {
      super.setUp();
      log.info("setUp() ....");
      boolean toStart = false;
      cache = PojoCacheFactory.createCache(CONFIG_FILENAME, toStart);
      cache.start();
      cache.attach("/aop/test", new HashMap());
      cachedMap = (Map) cache.find("/aop/test");
   }

   protected void tearDown() throws Exception
   {
      super.tearDown();
   }

   public void XtestDummy()
   {

   }
//
//   This is a bogus test. A key must be serializable since it part of an FQN.
//   Also it shouldn't be mutable.
//
//   public void testRecuriveMapKey()
//   {
//      IdObject id = new IdObject("1");
//      ValueObject value = new ValueObject(id, 3.0f);
//      cachedMap.put(id, value);
//   }

   public void testRecursiveList() throws Exception
   {
      ArrayList list = new ArrayList();
      list.add("1");
      cache.attach("list", list);
      list = (ArrayList) cache.find("list");
      list.add(list);
      System.out.println(list.toString());
   }

   public void testRecursiveSet() throws Exception
   {
      HashSet set = new HashSet();
      set.add("1");
      cache.attach("set", set);
      set = (HashSet) cache.find("set");
      set.add(set);
      System.out.println(set.toString());
   }

   public void testRecursiveMap() throws Exception
   {
      HashMap map = new HashMap();
      map.put("1", "1");
      cache.attach("map", map);
      map = (HashMap) cache.find("map");
      map.put("2", map);
      System.out.println(map.toString());
   }

} // class TestRunner


