/*
 * JBoss, Home of Professional Open Source
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

package org.jboss.cache.pojo.util;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import java.lang.reflect.Method;

/**
 * @author Ben Wang
 */

public class MethodCallTest extends TestCase
{
   Log log_ = LogFactory.getLog(MethodCallTest.class);

   public MethodCallTest(String name)
   {
      super(name);
   }

   protected void setUp() throws Exception
   {
      super.setUp();
      log_.info("setUp() ....");
   }

   protected void tearDown() throws Exception
   {
      super.tearDown();
   }

//   public void testDummy() {}

   public void testBasic() throws Throwable
   {
      Integer i = 1;
      Method method = Foo.class.getDeclaredMethod("setFoo",
              new Class[]{Integer.class});

      Object[] args = new Object[]{i};
      Foo foo = new Foo();
      MethodCall mc = new MethodCall(method, args, foo);

      mc.invoke();
   }

   public static Test suite() throws Exception
   {
      return new TestSuite(MethodCallTest.class);
   }


   public static void main(String[] args) throws Exception
   {
      junit.textui.TestRunner.run(MethodCallTest.suite());
   }

   public static class Foo
   {
      Integer i;

      public void setFoo(Integer i)
      {
         this.i = i;
      }

      public Integer getFoo()
      {
         return i;
      }
   }
}
