package jasco.runtime;

public class Advice {

	public enum Type {BEFORE,AFTER,AROUND,AROUND_THROWING,AROUND_RETURNING,AFTER_THROWING,AFTER_RETURNING, ISAPPLICABLE};
	
	public static String getNameForType(Type t) {
		
		switch(t) {
		
			case BEFORE:
				return "before";
			
			case AROUND:
				return "around";

			case AFTER:
				return "after";
				
			case ISAPPLICABLE:
				return "isApplicable";
				
			default:
					throw new IllegalArgumentException("not yest implemented");
		}
	}
	
	public static boolean hasReturnValue(Type t) {
		
		switch(t) {
		
			case BEFORE:
			case AFTER:
			case AFTER_RETURNING:
			case AFTER_THROWING:
				return false;
			
			case AROUND:
			case AROUND_RETURNING:
			case AROUND_THROWING:
			case ISAPPLICABLE:
				return true;

			default:
					throw new IllegalArgumentException("illegal type value "+t);
		}
	}
	
	public static String getSourceNameForType(Type t) {
		
		String pre = Advice.class.getName()+".Type.";
		switch(t) {
		
			case BEFORE:
				return pre+"BEFORE";
			
			case AROUND:
				return pre+"AROUND";

			case AFTER:
				return pre+"AFTER";
			
			case ISAPPLICABLE:
				return pre+"ISAPPLICABLE";
				
			default:
					throw new IllegalArgumentException("not yest implemented");
		}
	}

}
