/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 12-feb-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.aspect;

import jasco.runtime.aspect.annotation.Advice;
import jasco.tools.aspectparser.AspectClassesGenerator;
import jasco.util.JavassistHelper;
import jasco.util.generators.JavaGenerator;
import jasco.util.generators.MethodGenerator;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.util.Iterator;
import java.util.Vector;

import javassist.CtMethod;

/**
 * @author Wim 
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class HookHelper {

	public static boolean definesAdvice(Class clz, String adviceType) {
		
		try {
		String field = "_Jasco_has"+JavaGenerator.upperCaseFirst(adviceType);
		Field f = clz.getField(field);
		return true;
		}
		catch(Exception ex) {
			
		}
		return false;
		
	}
	
	private static final String COPY = "_copy";
	
	public static String getCopyName(String hookname) {
		
		return hookname+COPY;
	}
	
	public static String stripCopyName(String hookname) {
		
		if(hookname.endsWith(COPY))
			return hookname.substring(0,hookname.length()-COPY.length());
		else return hookname;
	}
	
	public static boolean definesAdvice(IHook cp, String adviceType) {
		
		return definesAdvice(cp.getClass(),adviceType);
	}
	
	
	public static Vector getRefinableMethods(Class hook) {
		
		Vector v = new Vector();
		
		Method[] methods = hook.getMethods();
		for(int i=0;i<methods.length;++i)
			if(isRefinableMethod(methods[i]))
				v.add(methods[i]);
			
		return v;
	}
	
	
	public static Vector getRefinableMethodNames(Class hook) {
		
		Vector v = new Vector();
		
		Iterator i = getRefinableMethods(hook).iterator();
		while(i.hasNext()) {
			Method next = (Method) i.next();
			v.add(next.getName());
		}
			
		return v;
	}
	
	/**
	 * @param method
	 * @return
	 */
	public static boolean isRefinableMethod(Method method) {
		
		return getRefinableAnnotation(method)!=null;
	}
	
	protected static Annotation getRefinableAnnotation(Method method) {
		
		Annotation[] annotations = method.getAnnotations();
		for(int i=0;i<annotations.length;++i)
			if(annotations[i].annotationType().getName().equals(AspectClassesGenerator.REFINABLE_ANNOTATION))
				return annotations[i];
			
		return null;
	}
	
	

	public static boolean isRefinableMethod(Class hook, MethodGenerator method) {
		
		Iterator i = getRefinableMethods(hook).iterator();
		while(i.hasNext()) {
			Method next = (Method) i.next();
			if(method.hasSameSignatureAs(next))
				return true;
		}
		return false;
		
	}
	
	public static boolean hasAdviceAnnotation(CtMethod method) {
		
		return JavassistHelper.hasAnnotation(method,Advice.class.getName());
	}

}
