package jasco.runtime.aspect;

import jasco.runtime.MethodJoinpoint;
import jasco.runtime.distribution.IHostSet;
import jasco.runtime.distribution.IHostSetBuilder;
import jasco.util.generators.JavaGenerator;

import java.util.Hashtable;

public class PCutpointConstructorExecutionHost extends
		PCutpointConstructorApplicationDesignator {
	
	private IHostSet host;
	private String strategy;
	
	public PCutpointConstructorExecutionHost(String hostDesc){
		this(hostDesc,null);
	}
	
	public PCutpointConstructorExecutionHost(String hostDesc, String strategy) {
		super(null);
		this.host=IHostSetBuilder.buildFrom(hostDesc,strategy);
		this.strategy=strategy;
	}

	@Override
	public boolean eval(MethodJoinpoint jp, Hashtable mappings, boolean forJutta) {
		
		if(forJutta)
			return true;
		
		boolean result= host.selectHostsByStrategy().containsLocalHost();
		return result;
	}
	
	public boolean doNotCache()  {
		
		return true;
	}

	@Override
	public String generateCreateCode(String argname) {
		
		argname+=" = new PCutpointConstructorExecutionHost(\""+host.toString()+"\"";
		
		if(strategy!=null)
			argname+=", \""+strategy+"\"";
		
		argname+=");"+JavaGenerator.NEWLINE;
		
		return argname;
	}

	@Override
	public String toDescString() {
		return "executionhost("+host.toString()+")";
	}

	public IHostSet getHost() {
		return host;
	}

}
