/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.aspect;

import jasco.runtime.MethodJoinpoint;

public class PCutpointConstructorOr extends PCutpointConstructorApplicationDesignator
{		
	public PCutpointConstructorOr(PCutpointConstructorApplicationDesignator param1, PCutpointConstructorApplicationDesignator param2)  {
	
		super(param1,param2);
	}
	
	public boolean eval(MethodJoinpoint jp, java.util.Hashtable mappings, boolean forJutta)  {
	
		return getParameter().eval(jp,mappings,forJutta) || getParameter2().eval(jp,mappings,forJutta);
	}
	
	public String generateCreateCode(String argname)  {
		
		String argname1 = getNextArgName();
		String argname2 = getNextArgName();
		
		String code = "";
		code+="PCutpointConstructorApplicationDesignator "+argname1+", "+argname2+";"+NEWLINE;
		code+=getParameter().generateCreateCode(argname1);
		code+=getParameter2().generateCreateCode(argname2);
		
		
		code+=""+argname+" = new PCutpointConstructorOr("+argname1+", "+argname2+");"+NEWLINE;
		return code;
	}
	
	public String toDescString()  {
	
		return getParameter().toDescString()+" || "+ getParameter2().toDescString();
	}
}