package jasco.runtime.aspect;

import jasco.options.Options;
import jasco.runtime.MethodJoinpoint;
import jasco.runtime.distribution.DistributedJascoMethod;
import jasco.runtime.distribution.IHostSet;
import jasco.runtime.distribution.IHostSetBuilder;
import jasco.util.generators.JavaGenerator;
import jasco.util.logging.Logger;

import java.util.Hashtable;

public class PCutpointConstructorPHost extends
		PCutpointConstructorApplicationDesignator {
	
	private IHostSet hostset;

	public PCutpointConstructorPHost(String hostDesc){
		super(null);
		this.hostset=IHostSetBuilder.buildFrom(hostDesc);
	}
	@Override
	public boolean eval(MethodJoinpoint jp, Hashtable mappings, boolean forJutta) {
		
		
		if(forJutta)
			return true;
		
		if(!(jp instanceof DistributedJascoMethod)) {
			System.out.println(Options.isDistributed());
			new Exception().printStackTrace();
			Logger.getInstance().showError("Distribution pointcut phost, but non distributed deployment! "+jp.getSignature());
			return false;
		}
		
		DistributedJascoMethod djp  = (DistributedJascoMethod) jp;
		
		boolean result= this.hostset.contains(djp.getHost());
	
		return result;
	}
	
	@Override
	public boolean doNotCache()  {
		
		return true;
	}

	@Override
	public String generateCreateCode(String argname) {
		
		return argname+" = new PCutpointConstructorPHost(\""+hostset.toString()+"\");"+JavaGenerator.NEWLINE;
	}

	@Override
	public String toDescString() {
		return "joinpointhost("+hostset.toString()+")";
	}
}
