/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 5-dec-2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.aspect;

import jasco.options.Options;
import jasco.runtime.MethodJoinpoint;
import jasco.runtime.hotswap.JAsCoClassLoader;
import jasco.util.generators.JavaGenerator;

import java.util.Hashtable;

import javassist.CtClass;
import javassist.NotFoundException;

/**
 * @author Wim
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class PCutpointConstructorTarget extends
		PCutpointConstructorApplicationDesignator {
	
	private String m_targetClassName;
	private CtClass m_targetClassJavassist = null;
	private Class m_targetClass = null;
	
	/**
	 * @param param
	 */
	public PCutpointConstructorTarget(
			String param) {
		super(null);
		m_targetClassName=param;
	}
	
	protected void initTargetClassJavassist() {
		
		try {
			m_targetClassJavassist=JAsCoClassLoader.getSingleton().loadClass(m_targetClassName);
			}catch(NotFoundException ex) {
				jasco.util.logging.Logger.getInstance().showError(ex);
			}
	}
	
	protected void initTargetClass() {
		
		try {
			m_targetClass=Options.loadClass(m_targetClassName);
			}catch(ClassNotFoundException ex) {
				jasco.util.logging.Logger.getInstance().showError(ex);
			}
	}
	
	/**
	 * @param param
	 * @param param2
	 */
	public PCutpointConstructorTarget(
			PCutpointConstructorApplicationDesignator param,
			PCutpointConstructorApplicationDesignator param2) {
		super(param, param2);
		// TODO Auto-generated constructor stub
	} 

	/* (non-Javadoc)
	 * @see jasco.runtime.aspect.PCutpointConstructorApplicationDesignator#eval(jasco.runtime.RuntimeContext, java.util.Hashtable, boolean)
	 */
	public boolean eval(MethodJoinpoint jp, Hashtable mappings,
			boolean forJutta) {
	
		if(jp.getCalledObject()==null) //static method
			return false;
		
		try {
		if(forJutta) { //static analysis, is this ever possible
			CtClass jpClass = JAsCoClassLoader.getSingleton().loadClass(jp.getClassName());
			return getTargetClassJavassist().subtypeOf(jpClass)||jpClass.subtypeOf(getTargetClassJavassist());
		}
		else return jp.getCalledObject().getClass().isAssignableFrom(getTargetClass());
		
		}catch(NotFoundException ex) {
			jasco.util.logging.Logger.getInstance().showError(ex);
			return false;
		}
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.aspect.PCutpointConstructorApplicationDesignator#generateCreateCode(java.lang.String)
	 */
	public String generateCreateCode(String argname) {
		return argname+" = new PCutpointConstructorTarget(\""+getTargetClassName()+"\");"+JavaGenerator.NEWLINE;
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.aspect.PCutpointConstructorApplicationDesignator#toDescString()
	 */
	public String toDescString() {
		// TODO Auto-generated method stub
		return null;
	}
	
	public String getTargetClassName() {
		
		return m_targetClassName;
	}
	
	public CtClass getTargetClassJavassist() {
		
		if(m_targetClassJavassist==null)
			initTargetClassJavassist();
		return m_targetClassJavassist;
	}
	
	public Class getTargetClass() {
		
		if(m_targetClass==null)
			initTargetClass();
		return m_targetClass;
	}
}
