/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.aspect;

import java.util.Vector;


public class Transition implements Comparable {  
		
	private int label = -1;
	private PCutpointConstructorApplicationDesignator designator;
	private State start;
	
	//Guards were added to support initially the causal and conc modifiers in the transitions
	private Vector guards;
	
	public Transition(State start, int label, PCutpointConstructorApplicationDesignator des)  {
		this.label=label;
		this.designator = des;
		this.start=start;
	}
	
	public Transition(State start, int label, PCutpointConstructorApplicationDesignator des, Vector guards)  {
		this.label=label;
		this.designator = des;
		this.start=start;
		this.guards=guards;
	}
	
	public Vector getGuards() {
		return guards;
	}

	public int getLabel()  {
	
		return label;
	}
	
	public PCutpointConstructorApplicationDesignator getParam()  {
	
		return designator;
	}
	
	public State getStartState()  {
	
		return start;
	}
	
	public State getDestState()  {
	
		return start.getDestState(this);
	}
	
	public int compareTo(Object o)  {
		
		if (o instanceof Transition)  {
			Transition trans = (Transition) o;
			return label-trans.getLabel(); 
		}
		else return -1;
	}
}