/*
 * Created on 8-apr-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.cache;

import jasco.runtime.DoNotCache;
import jasco.runtime.MethodJoinpoint;
import jasco.runtime.aspect.IHook;
import jasco.runtime.connector.CombinationStrategy;
import jasco.runtime.connector.Connector;
import jasco.runtime.connector.HookElement;
import jasco.runtime.connector.HookList;

import java.util.Enumeration;
import java.util.Iterator;
import java.util.Vector;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class CombinationStrategyResolver {

	private HookList hlist;
	private Vector combStrats;
	
	public CombinationStrategyResolver(Vector hookElements) {
		super();
		
		combStrats=getNonCachableCombStrats(hookElements);
		hlist=new HookList(hookElements);
	}
	
	public void executeCombStrats(MethodJoinpoint jp) {
		hlist.resetChanged();
		
		Iterator i = combStrats.iterator();
		while(i.hasNext()) {
			CombinationStrategy strategy = (CombinationStrategy) i.next();
			strategy.validateCombinations(hlist);
		}
	}
	
	public boolean shouldExecute(IHook hook) {
		
		return shouldExecute(hook,hlist);
	}
	
	public static final boolean shouldExecute(IHook hook, HookList hlist) {
		
		if(!hlist.isChanged())
			return true;
		else return hlist.contains(hook);
	}
	
	public static final Vector getNonCachableCombStrats(Vector hookElements) {
		
		Vector res= new Vector();
		for(int i=0;i<hookElements.size();++i) 
			res.addAll(getNonCachableCombStrats(((HookElement)hookElements.elementAt(i)).getCutpoint()._Jasco_getConnector()));
			
		return res;
	}
	
	public static final boolean hasNonCachableCombStrats(Vector hookElements) {
		
		return !(getNonCachableCombStrats(hookElements).isEmpty());
	}
	
	
	public static final Vector getNonCachableCombStrats(Connector c) {
		
		Vector res=new Vector();
		Enumeration enum1 = c.getCombinationStrategies();
		while(enum1.hasMoreElements()) {
			CombinationStrategy strat = (CombinationStrategy) enum1.nextElement();
			if(strat instanceof DoNotCache)
				res.add(strat);
		}
		return res;
	}

}
