/*
 * Created on 11-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.connector;

import jasco.runtime.MethodJoinpoint;

import java.util.Iterator;
import java.util.Vector;

import javassist.ClassPool;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * Class that represents more than one method signature binding for the same abstract method parameter
 * e.g, two bindings:
 * 
 * ... = new myHook({void test.boe1(), * test.*(*)});
 * 
 * See MethodSignature 
 * 
 * @author Wim
 */

public class CombinedMethodSignature implements ISignatureMatcher {

	private Vector signatures;
	public CombinedMethodSignature(Vector v) {
		super();
		this.signatures=v;
		
	}

	
	public Iterator getSignatures() {
		
		return signatures.iterator();
	}
	
	public static final CombinedMethodSignature build(Vector signatures ) {
		
		return new CombinedMethodSignature(signatures);
	}


	public boolean matchesJoinpoint(MethodJoinpoint jp) {
		
		Iterator i = this.getSignatures();
		while(i.hasNext()) {
			
			ISignatureMatcher matcher = (ISignatureMatcher) i.next();
			if(matcher.matchesJoinpoint(jp))
				return true;
		}
		return false;
		
	}


	public boolean matchesClass(String clzName, ClassLoader classLoader) {
		Iterator i = this.getSignatures();
		while(i.hasNext()) {
			
			ISignatureMatcher matcher = (ISignatureMatcher) i.next();
			if(matcher.matchesClass(clzName, classLoader))
				return true;
		}
		return false;
	}


	public boolean matchesClass(String clzName) {
		Iterator i = this.getSignatures();
		while(i.hasNext()) {
			
			ISignatureMatcher matcher = (ISignatureMatcher) i.next();
			if(matcher.matchesClass(clzName))
				return true;
		}
		return false;
	}

	public boolean matchesClass(String clzName, ClassPool pool) {
		Iterator i = this.getSignatures();
		while(i.hasNext()) {
			
			ISignatureMatcher matcher = (ISignatureMatcher) i.next();
			if(matcher.matchesClass(clzName, pool))
				return true;
		}
		return false;
	}
}
