/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 22-okt-2004
 */
package jasco.runtime.connector;

import java.util.HashMap;
import java.util.Vector;

/**
 * @author Wim
 */
public class OnEventTable {

	private static HashMap map = new HashMap();
	private final static Vector  EMPTY_VECTOR = new Vector();
	
	private OnEventTable() {
	
	}
	
	public static void addListener(Object object, String listenername, Object listener) {
		
		HashMap objectmap = (HashMap) map.get(object);
		if(objectmap==null) {
			objectmap=new HashMap();
			map.put(object,objectmap);
		}
		
		Vector listeners = (Vector) objectmap.get(listenername);
		if(listeners==null) {
			listeners = new Vector();
			objectmap.put(listenername,listeners);
		}
		
		listeners.add(listener);
	}
	
	public static void removeListener(Object object, String listenername, Object listener) {
		
		HashMap objectmap = (HashMap) map.get(object);
		if(objectmap==null)
			return;
		
		Vector listeners = (Vector) objectmap.get(listenername);
		if(listeners==null) {
			return;
		}
		
		listeners.remove(listener);
		if(listeners.size()==0) {
			objectmap.remove(listenername);
			if(objectmap.size()==0)
				map.remove(object);
		}		
	}
	
	public static Vector getListeners(Object object, String listenername) {
		
		HashMap objectmap = (HashMap) map.get(object);
		if(objectmap==null)
			return EMPTY_VECTOR;
		
		Vector listeners = (Vector) objectmap.get(listenername);
		if(listeners==null) {
			return EMPTY_VECTOR;
		}
		else return listeners;
	}
}
