package jasco.runtime.distribution;

import jasco.runtime.DefaultTrapExecutor;
import jasco.runtime.JascoMethod;
import jasco.util.distribution.JascoCustomSocketConfigurator;
import jasco.util.distribution.JascoThreadCflow;

public class DistributedTrapExecutor extends DefaultTrapExecutor {
	
	public DistributedTrapExecutor() {
		if(DistributedOptions.getInstance().getUseCustomizedSockets())
			JascoCustomSocketConfigurator.configureSocketFactory();
		
		DistributePointcutHandler.init();
		//DistributedConnectorHandler.getInstance();
		DistributedSharingManager.getInstance();
	}
	
	public boolean isAdapted(JascoMethod method) {
		
		return true;
	}
	
	public Object executeTrap(JascoMethod method) throws Exception{
		
		if(!(method instanceof DistributedJascoMethod)) {
			jasco.util.logging.Logger.getInstance().showError("DistributedTrapExecutor encountered non-disributed joinpoint!");
			return super.executeTrap(method);
		}
		
		DistributedJascoMethod jp = (DistributedJascoMethod) method;
		
		DistributePointcutHandler.getInstance().sendNotification(jp);
		
		return super.executeTrap(method);
	}
}
 