package jasco.runtime.distribution;

import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.FutureTask;

public class FutureManager {
	
	private static FutureManager instance = new FutureManager();
	public static FutureManager getInstance() {
		
		return instance;
	}
	
	
	private long idgen = 0;
	private Map<Long,FutureTask> store = new TreeMap<Long,FutureTask>(); 
	
	public ObjectFutureWrapper registerFutureTask(FutureTask task) {
		
		long id = idgen++;
		store.put(id,task);
		ObjectFutureWrapper wrapper = new ObjectFutureWrapper(id,Host.getLocalHost());
		return wrapper;
	}
	
	public Object retrieveFutureResult(long taskid) {
		
		FutureTask future = store.get(taskid);
		try {
			return future.get();
		} catch (InterruptedException e) {
			e.printStackTrace();
			throw new IllegalArgumentException("error while accessing AWED transparant future",e);
		} catch (ExecutionException e) {
			e.printStackTrace();
			throw new IllegalArgumentException("error while accessing AWED transparant future",e);
		}
	}
	
	
}
