package jasco.runtime.distribution;

import java.net.UnknownHostException;

public class NeighborhoodBuilder {
	
	private static NeighborhoodBuilder _instance = new NeighborhoodBuilder();
	
	private NeighborhoodBuilder() {
		super();
	}
	
	public static NeighborhoodBuilder getInstance() {
		
		return _instance;
	}
	
	public INeighborhood getNeighborhood(String name) {
		
		HostSet set = (HostSet) IHostSetBuilder.buildFrom(IHostSetBuilder.NEIGH+name);
		return set;
	}
	
	public void addHostToNeighborhood(String hostname,String neighborhood) {
		
		INeighborhood neigh = getNeighborhood(neighborhood);
		neigh.addHost(Host.buildFrom(hostname));
	}
	
	public void removeHostfromNeighborhood(String hostname,String neighborhood) {
		
		INeighborhood neigh = getNeighborhood(neighborhood);
		neigh.removeHost(Host.buildFrom(hostname));
	}
}
