/**
 * 
 */
package jasco.runtime.distribution;

import jasco.runtime.JascoMethod;
import jasco.runtime.distribution.remoteref.RemoteAWEDReference;
import jasco.util.distribution.JascoDistributionConnectorGenerator;

import java.lang.ref.WeakReference;
import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Map;

/**
 * @author dnielben
 *
 */
public class ReferenceManager {
	
	private static ReferenceManager _instance= new ReferenceManager();
	private JascoDistributionConnectorGenerator aConGenerator =
		new JascoDistributionConnectorGenerator();
	
	// TODO Check the implementation to asure performance
	// and garbage collection
	// 
	private Map<String, WeakReference> m = new HashMap();
	private long id = -1;
	/**
	 * 
	 */
	private ReferenceManager() {
		super();
		// TODO Auto-generated constructor stub
	}
	
	static public ReferenceManager getInstance(){
		return _instance;
	}
	
	/**
	 *  Redirects the call to the apropiate remote reference
	 */
	public Object redirect(JascoMethod jm, long refId){
		RemoteAWEDReference aRemoteReference= (RemoteAWEDReference )getDummyInstance(refId);
		Object res = null;
		try {
			res = aRemoteReference.execute(jm);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return res;
	}
	
	
	public Object getDummyInstance(long instanceid){
		return m.get(instanceid).get();
	}
	
	
	/**This Method adds the dummy instance and creates the corresponding
	*connector to aspectize the instance and create the proxy behavior*/
	public synchronized long addDummyInstance(Object anObject){
		id++;
		m.put(new Long(id).toString() , new WeakReference(anObject));
		aConGenerator.generateConnForProxy(anObject.getClass(), id);
		return id;
	}
}
