package jasco.runtime.distribution.causality;

import org.jgroups.protocols.AWEDLOCALCLOCKMANAGEMENT;
import org.jgroups.protocols.TransportedVectorTime;


/**
 * LDBN 6-3-2008 This class is a singleton that refers to the protocol
 * AWEDLOCALCLOCKMANAGEMENT. The class refers only one manager. Thus it
 * only allows one vector clock for each JVM. The manager is now in the protocol
 * stack of JGroups. This seems unclean, it could be refactored out of the 
 * Jgroups Stack. but, in the other hand, the stack is the place to
 * manage the addition and deletion of new hosts.
 * 
 * @author dnielben
 *
 */
public class LocalVectorClock {
	private static LocalVectorClock instance = new LocalVectorClock();
	
	private AWEDLOCALCLOCKMANAGEMENT localClockManager= null;
	
	static public LocalVectorClock getInstance(){
		return instance;
	}

	public TransportedVectorTime getLocalClock() {
		return localClockManager.getCurrentVectorTime();
	}

	public void computeCausalLocalClock(TransportedVectorTime tvt) {
		localClockManager.computeCurrentVectorTime(tvt);
	}
	
	public void setManager(AWEDLOCALCLOCKMANAGEMENT lcm){
		localClockManager = lcm;
	}
	
}
