package jasco.runtime.distribution.hostselection;

import jasco.runtime.distribution.Host;

import java.util.Random;
import java.util.Vector;

public class RandomHostSelectionStrategy implements IHostSelectionStrategy {
	
	private Random random = new Random();
	
	public RandomHostSelectionStrategy() {}
	
	public Vector<Host> selectHosts(Vector<Host> hosts) {
		
		Vector<Host> v = new Vector<Host>();
		v.add(selectHost(hosts));
		
		return v;
	}
	
	
	public Host selectHost(Vector<Host> hosts) {
		if(hosts.size()==0)
			return null;
		
		if(hosts.size()==1)
			return hosts.firstElement();
		
		float boe = random.nextFloat();
		int res = new Float(boe*(hosts.size()-1)).intValue();
		
		return hosts.elementAt(res);
	} 

}
