/*
 * Created on 24-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.hotswap;

import jasco.runtime.MethodJoinpoint;

import java.util.Map;
import java.util.TreeMap;

import javassist.CtMethod;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class JoinpointContainer {

	private static JoinpointContainer instance = new JoinpointContainer();
	private Map methods = new TreeMap();
	 
	private JoinpointContainer() {
		super();
	}
	
	public static JoinpointContainer getInstance() {
		
		return instance;
	}
	
	public void addJoinpoint(CtMethod method, MethodJoinpoint jp) {
		
		methods.put(getUniqueId(method),jp);
	}
	
	/**
	 * @param method
	 * @return
	 */
	public String getUniqueId(CtMethod method) {
		
		
		return method.getDeclaringClass().getName()+"."+method.getName()+"."+method.getSignature();
	}
	
	public MethodJoinpoint getJoinpoint(String method) {
		
		return (MethodJoinpoint) methods.get(method);
	}

	public MethodJoinpoint getJoinpoint(CtMethod method) {
		
		return getJoinpoint(getUniqueId(method));
	}
}
