/*
 * Created on 28-apr-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.inline;

import jasco.runtime.MethodJoinpoint;
import jasco.runtime.transform.FieldGenerator;
import jasco.util.generators.JavaGenerator;
import jasco.util.logging.Logger;

import java.util.HashMap;
import java.util.Map;
import java.util.Vector;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class FieldGeneratorPropertyStore {

	public static FieldGeneratorPropertyStore instance = new FieldGeneratorPropertyStore();
	private Map fieldGeneratorInits = new HashMap();
	
	
	private FieldGeneratorPropertyStore() {
		super();
	}
	
	public static FieldGeneratorPropertyStore getInstance() {
		
		return instance;
	}
	
	public void addFieldGeneratorInit(FieldGenerator fgenerator, String methodName, Vector hooks, MethodJoinpoint jp) {
		
		addFieldGeneratorInit(fgenerator.getFieldClass().getName(),methodName,hooks,jp);
	}


	public void addFieldGeneratorInit(String name, String methodName, Vector hooks, MethodJoinpoint jp) {
		Map methods = (Map)fieldGeneratorInits.get(name);
		if(methods==null) {
			methods=new HashMap();
			fieldGeneratorInits.put(name,methods);
		}
		methods.put(methodName,new FieldGeneratorProperty(hooks,jp));
	}
	
	public FieldGeneratorProperty checkoutFieldGeneratorProperty(String name, String methodName) {
		
		Map methods = (Map)fieldGeneratorInits.get(name);
		if(methods==null)
			throw new IllegalArgumentException("field generator property not found! "+name+"."+methodName);
		FieldGeneratorProperty property = (FieldGeneratorProperty) methods.get(methodName);
		if(property==null)
			throw new IllegalArgumentException("field generator property not found! "+name+"."+methodName);
		
		methods.remove(methodName);
		if(methods.isEmpty())
			fieldGeneratorInits.remove(name);
		
		return property;
	}
	
	public void initFieldGenerator(String name, String methodName) {
		try {
		FieldGeneratorProperty property=	checkoutFieldGeneratorProperty(name,methodName);
		Class javaClass = Class.forName(name);
		
		
		java.lang.reflect.Method m = javaClass.getMethod(methodName,new Class[]  {Vector.class,MethodJoinpoint.class});
		m.invoke(null,new Object[] {property.getHooks(),property.getJP()});
		}catch(Throwable ex) {
			Logger.getInstance().showFullError(ex);
		}
	}

	/**
	 * @param name
	 * @param myInitName
	 * @return
	 */
	public String generateFInitCode(String name, String myInitName) {
		
		String code = "";
		code+=FieldGeneratorProperty.class.getName()+ " property = ";
		code+=this.getClass().getName()+"#getInstance().checkoutFieldGeneratorProperty(\""+name+"\", \""+myInitName+"\");"+JavaGenerator.NEWLINE;
		code+=myInitName+"(property.getHooks(),property.getJP());"+JavaGenerator.NEWLINE;
		return code;
	}
}
