/*
 * Created on 12-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.mixin;

import jasco.runtime.MethodJoinpoint;

import java.lang.annotation.Annotation;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class DummyMixinJP implements MethodJoinpoint {
	
	private Object targetObject = null;
	private Class targetClass = null;
	private static final Class[] EMPTY_CLASS_ARRAY = new Class[0];
	private static final String[] EMPTY_STRING_ARRAY = new String[0];
	private static final Annotation[] EMPTY_ANNOTATION_ARRAY = new Annotation[0];
	private static final String MIXIN_DUMMY_ID = "_jasco_virtual_MIXIN";
	
	public DummyMixinJP(Object target) {
		this(target,target.getClass());
	}
	
	public DummyMixinJP(Class target) {
		this(null,target);
	}
	
	public DummyMixinJP(Object targetObject, Class targetClass) {
		super();
		this.targetClass=targetClass;
		this.targetObject=targetObject;
	}


	public Class[] getExceptionTypes() {
		return EMPTY_CLASS_ARRAY;
	}

	public Class getReturnType() {
		return Object.class;
	}

	public String getFullName() {
		return MIXIN_DUMMY_ID;
	}

	public String getSignature() {
		
		return MIXIN_DUMMY_ID;
	}

	public boolean isExecution() {
		return true;
	}

	public boolean isCall() {
		return true;
	}

	public String getName() {
		return MIXIN_DUMMY_ID;
	}

	public Class loadClass() {
		return targetClass;
	}

	public Annotation[] getAnnotations() {
		return EMPTY_ANNOTATION_ARRAY;
	}

	public Class[] getActualArgumentTypes() {
		// TODO Auto-generated method stub
		return EMPTY_CLASS_ARRAY;
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getFormalArgumentTypes()
	 */
	public Class[] getFormalArgumentTypes() {
		// TODO Auto-generated method stub
		return EMPTY_CLASS_ARRAY;
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getClassName()
	 */
	public String getClassName() {
		// TODO Auto-generated method stub
		return targetClass.getName();
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getModifiers()
	 */
	public int getModifiers() {
		// TODO Auto-generated method stub
		return 0;
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getArgumentsArray()
	 */
	public Object[] getArgumentsArray() {
		// TODO Auto-generated method stub
		return EMPTY_CLASS_ARRAY;
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getCalledObject()
	 */
	public Object getCalledObject() {
		// TODO Auto-generated method stub
		return targetObject;
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#invokeJAsCoMethod()
	 */
	public Object invokeJAsCoMethod() throws Exception {
		throw new IllegalArgumentException("this is a dummy jp, should never occur!!!!!");
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#invokeOriginalJAsCoMethod()
	 */
	public Object invokeOriginalJAsCoMethod() throws Exception {
		throw new IllegalArgumentException("this is a dummy jp, should never occur!!!!!");
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#invoke(java.lang.Object, java.lang.Object[])
	 */
	public Object invoke(Object obj, Object[] args) throws Exception {
		throw new IllegalArgumentException("this is a dummy jp, should never occur!!!!!");
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#invokeOriginal(java.lang.Object, java.lang.Object[])
	 */
	public Object invokeOriginal(Object obj, Object[] args) throws Exception {
		throw new IllegalArgumentException("this is a dummy jp, should never occur!!!!!");
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#invokeAgain()
	 */
	public Object invokeAgain() throws Exception {
		throw new IllegalArgumentException("this is a dummy jp, should never occur!!!!!");
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#invokeAgain(java.lang.Object, java.lang.Object[])
	 */
	public Object invokeAgain(Object calledobject, Object[] args) {
		throw new IllegalArgumentException("this is a dummy jp, should never occur!!!!!");
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#invokeNoAspectAgain()
	 */
	public Object invokeNoAspectAgain() throws Exception {
		throw new IllegalArgumentException("this is a dummy jp, should never occur!!!!!");
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getClassLoader()
	 */
	public ClassLoader getClassLoader() {
		return targetClass.getClassLoader();
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getReturnTypeName()
	 */
	public String getReturnTypeName() {
		return getReturnType().getName();
	}

	/* (non-Javadoc)
	 * @see jasco.runtime.MethodJoinpoint#getFormalArgumentTypeNames()
	 */
	public String[] getFormalArgumentTypeNames() {
	
		return EMPTY_STRING_ARRAY;
	}

	public int getSourceLocation() {
		return 0;
	}
}
