/*
 * Created on 3-mrt-2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package jasco.runtime.refinements;

import jasco.runtime.aspect.IHook;
import jasco.runtime.mixin.NoMixinFound;

import java.util.Vector;

/* 
 Copyright (C) 2002-2005 JAsCo Development Team
 http://ssel.vub.ac.be/jasco
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU Lesser General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU Lesser General Public License for more details.

 You should have received a copy of the GNU Lesser General Public
 License along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 USA 
 */

/**
 * @author Wim
 */

public class ConnectorInlineRefinement implements IRefinement {
	
	private Vector targetCutpoints = new Vector();
	private int prio = Integer.MAX_VALUE;
	private Vector implementedMethods;
	
	/**
	 * 
	 */
	public ConnectorInlineRefinement(IHook targetCutpoint, Vector implementedMethods) {
		super();
		this.targetCutpoints.add(targetCutpoint);
		this.implementedMethods=implementedMethods;
	}
	
	public ConnectorInlineRefinement(IHook targetCutpoint, String[] implementedMethodsArray) {
		this(targetCutpoint,new Vector());
		
		for(int i=0;i<implementedMethodsArray.length;++i)
			implementedMethods.add(implementedMethodsArray[i]);
	}
	
	public void addTargetCutpoint(IHook cp) {
		
		targetCutpoints.add(cp);
	}
	
	public boolean isApplicable(Class targetClass, IHook hook, String method) {
		
		return targetCutpoints.contains(hook)&&implementedMethods.contains(method);
	}
	
	public boolean isApplicableForHook(IHook cp) {
		
		return targetCutpoints.contains(cp);
	}
	
	public int getPriority() {
		
		return prio;
	}
	
	protected Object mixinOf(Object target, Class mixin) throws NoMixinFound {
	
		return jasco.runtime.mixin.MixinManager.getInstance().mixinOf(target,mixin);
	}
	

}
