/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.runtime.transform;

import javassist.CtClass;
import javassist.CtMethod;
import javassist.CtNewMethod;

public class ClassPreTransformer extends MethodProcessor  {
		
	public boolean processMethod(CtMethod themethod, int methodid) throws Exception {
		
		String newname = getNewMethodName(themethod);
		
		int modifiers = themethod.getModifiers();
		modifiers=javassist.Modifier.setPublic(modifiers);
		
		CtMethod copy = CtNewMethod.make(modifiers,themethod.getReturnType(),newname,themethod.getParameterTypes(),
				themethod.getExceptionTypes(), null, getTargetClass());
		
		copy.getMethodInfo().setCodeAttribute(themethod.getMethodInfo().getCodeAttribute());
		TransformerConstants.makeSynthetic(copy);
		
		if(!methodDefined(getTargetClass(),copy))
			getTargetClass().addMethod(copy); //addmethod0 in order to make sure that there is no test (see agus bug with 2 methods returning different types)
		 
		return true;
	}
	
	protected boolean methodDefined(CtClass clz, CtMethod method) {
		
		try {
			
			clz.getMethod(method.getName(),method.getSignature());
			return true;
		}
		catch(javassist.NotFoundException ex) {
		}
		
		return false;
	}
}
	
		
	
	
	