/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 25-nov-2004
 */
package jasco.testing;

import jasco.Jasco;
import jasco.options.Options;

import java.lang.reflect.Method;
import java.util.Vector;

/** 
 * @author Wim
 * TODO !!! extend this interface test to more methods!!!!
 */
public class RunJAsCoInterfaceTest extends RunJAsCoProgramTest {

	
	public RunJAsCoInterfaceTest() {
		super("jasco.testing.RunJAsCoInterfaceTest", "jasco.Jasco interface", TRANSFORM_BEAN, true);
	}
	
	public static void main(String[] args) throws Throwable {
		
		jasco.options.Options.doTransformEvents(true);
		jasco.options.Options.setDeleteTempFiles(false);
		Options.setOutputDir("./testing/Generated");
		
		Jasco.compileAspect("./testing/basic.asp");
		
		Jasco.compileAndLoadConnector("./testing/basicConnector.con");
		Jasco.transformBeanInOutputDir("javax.swing.MyJButton",new Vector());
		
		Class button = Class.forName("javax.swing.MyJButton");
		Object b = button.newInstance();
		Method m = button.getMethod("addActionListener", new Class[] {Class.forName("java.awt.event.ActionListener")});
		Object res = m.invoke(b,new Object[] {null});
	}
	
	public boolean checkOutput(StringBuffer output) {
		
		String res = output.toString();
		
		return res.indexOf("EXEC: addActionListener IN javax.swing.MyJButton")!=-1;
		
		
	}
}
