/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.aspectparser;

import jasco.runtime.aspect.PCutpointConstructorApplicationDesignator;
import jasco.tools.jascoparser.PJAsCoParseElement;

import java.util.Iterator;
import java.util.Vector;

public class PCutpointConstructor extends PJAsCoParseElement 
{

	private Vector cutpointmethods = new Vector();
	private String constructorbody = null;
	private PCutpointConstructorApplicationDesignator designator = null;
	private String carmaPointcut = null;
	
	PCutpointConstructor()
	{
	}
	
	public String getCarmaPointcut() {
		
		return carmaPointcut;
	}
	
	public boolean hasCarmaPointcut() {
		
		return getCarmaPointcut()!=null;
	}
	
	public void setCarmaPointcut(String b) {
		
		carmaPointcut=b;
	}
	
	public PCutpointConstructor copy() {
		PCutpointConstructor copy=null;
		try {
			copy = (PCutpointConstructor) clone();
		
		copy.designator=designator.deepCopy();
		} catch (CloneNotSupportedException e) {
		
			jasco.util.logging.Logger.getInstance().showError(e);
		}
		return copy;
	}

	
	public void addCutpointConstructorMethod(PCutpointConstructorMethod aMethod)
	{
		cutpointmethods.add(aMethod);
	}
	
	public Iterator getCutpointConstructorMethods() 
	{
		return cutpointmethods.iterator();
	}
	
	public int getNoCutpointConstructorMethods() 
	{
		return cutpointmethods.size();
	}
	
	public void setConstructorBody(String aBody) 
	{
		constructorbody = aBody;
	}
	
	public String getConstructorBody()
	{
		return constructorbody;
	}
	
	public void setConstructorApplicationDesignator(PCutpointConstructorApplicationDesignator s)  {
	
		this.designator=s;
	}
	
	public PCutpointConstructorApplicationDesignator getConstructorApplicationDesignator()  {
	
	 	return designator;
	}
	
	public int getNumberTag(String arg)  {
	
		for(int i=0; i<cutpointmethods.size(); ++i)  {
			PCutpointConstructorMethod m = (PCutpointConstructorMethod) cutpointmethods.elementAt(i);
			if(m.getCutpointConstructorMethodName().equals(arg))
				return i;
		}
		
		return -1;	
	}
	
	public	PCutpointConstructorMethod getMethodForTag(String tag)  {
	
		return (PCutpointConstructorMethod) cutpointmethods.elementAt((new Integer(tag).intValue()));
	}
	
	public	PCutpointConstructorMethod getMethodForTag(int tag)  {
	
		return (PCutpointConstructorMethod) cutpointmethods.elementAt(tag);
	}
}