/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.aspectparser;

import jasco.runtime.aspect.PCutpointConstructorApplicationDesignator;
import jasco.tools.jascoparser.PJAsCoParseElement;

import java.util.Iterator;
import java.util.Vector;

public class PRegularConstructorStatement extends PJAsCoParseElement {

	private String name;
	private PCutpointConstructorApplicationDesignator designator;
	private Vector next;
	private int id;
	
	// Added to support the conc and causal modifiers, but it could be used to add more sophisticated
	// guards
	private Vector guards;
	
	private static int nextid=0;
	public static final String START = "start";
	public static final String STOP = "stop";

	public PRegularConstructorStatement(String name, PCutpointConstructorApplicationDesignator designator, Vector next)  {
	
		this.name=name;
		this.designator=designator;
		this.next=next;
		this.id=nextid++;
	}
	
	public PRegularConstructorStatement(String name, PCutpointConstructorApplicationDesignator designator, Vector next, Vector guards)  {
		
		this.name=name;
		this.designator=designator;
		this.next=next;
		this.id=nextid++;
		this.guards=guards;
	}
		
	public String getName()  {
	
		return name;
	}
	
	public PCutpointConstructorApplicationDesignator getPointcut()  {
	
		return designator;
	}
	
	public Iterator getNext()  {
		
		return next.iterator();
	}
	public int getID()  {
	
		return id;
	}

	public Vector getGuards() {
		return guards;
	}

}