/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.gui;

import jasco.options.Options;
import jasco.runtime.aspect.IHook;
import jasco.runtime.aspect.PCutpointConstructorApplicationDesignator;
import jasco.util.SwingFactory;

import java.lang.reflect.Field;

import javax.swing.BorderFactory;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.BevelBorder;

public class HookTreeNode extends AbstractTreeNode {
	
	private IHook hook = null;
	
	public HookTreeNode(String name)  {
	
		super(name);
		setIcon(SwingFactory.getIcon("hook.gif"));
	}
	
	public IHook getHook()  {
	
		return hook;
	}
	
	public void setHook(IHook h)  {
	
		hook=h;
	}
	
	public void initInfoPanel(JPanel infoPanel)  {
		
		JLabel top = createTop(getName());
		top.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		
		
		infoPanel.add("North",top);
		
		JPanel main=new JPanel();
		
		
		
		
		try {
		String s = getHookConstructor();
		JLabel constr = new JLabel("Constructor: ");
		JLabel val = new JLabel(s);
		
		main.add(constr);
		main.add(val);
		
		}
		catch(Exception ex)  {
			JLabel error = new JLabel("Failed loading hook: "+getName());
			main.add(error);
		}
		
		infoPanel.add(main);
			
	}
	
	public String getHookConstructor() throws Exception {
	
		String clname = Options.getRealHookClassName(getName());
		Class c = Options.loadClass(clname);
		
		Field f = c.getField(Options.ASPECT_FIELD);
		Object o = f.get(getHook());
		PCutpointConstructorApplicationDesignator d = (PCutpointConstructorApplicationDesignator) o;
		d.resetArgNames();
		
		return d.toDescString();
	}
	
}
