/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.jascoparser;

import jasco.util.generators.JavaGenerator;

import java.util.Vector;

public class PJavaCode
{
	private Vector javacodes = new Vector();
	private Vector linenumbers = new Vector();
 	
	public PJavaCode()
	{
	}
	
	public int getJavaCodeSize()
	{
		return javacodes.size();
	}
	
	public void addJavaCode(String aJavaCode,int aLineNumber) 
	{
		javacodes.add(aJavaCode);
		linenumbers.add(new Integer(aLineNumber));
	}
	
	public void insertJavaCode(String aJavaCode,int aLineNumber) 
	{
		javacodes.insertElementAt(aJavaCode,0);
		linenumbers.insertElementAt(new Integer(aLineNumber),0);
	}
	
	public int getLineNumber(int aIndex)
	{
		return ((Integer)linenumbers.elementAt(aIndex)).intValue();
	}
	
	public String getJavaCode(int aIndex)
	{
		return (String)javacodes.elementAt(aIndex);
	}
	
	public String toString() {
		
		String tmp = "";
		java.util.Iterator i = javacodes.iterator();
		java.util.Iterator j = linenumbers.iterator();
		while(i.hasNext()) {
			String code = (String) i.next();
			Integer line = (Integer) j.next();
			
			tmp+=code+"//"+line+JavaGenerator.NEWLINE;
		}
		
		return tmp;
	}
}