/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.tools.traversalparser;

import jasco.tools.jascoparser.PImports;

import java.util.Iterator;
import java.util.Vector;

public class TraversalSpec  {

	private Vector hookInstances = new Vector();
	private String strategy = "";
	private String packageStr = "";
	private PImports importPackages = new PImports();
	private Vector combinations = new Vector();
	private String name = "";
	
	public TraversalSpec()  {
	}
	
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}
	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	public void addCombinationStrat(String code)  {
		
		combinations.add(code);
	}
	
	public Iterator getCombinationStrats()  {
		
		return combinations.iterator();
	}
	
	public String getPackageName() {
		
		//System.out.println(packageStr);
		return packageStr;
	}
	
	public void setPackageName(String str) {
	
		packageStr=str;
	}
	
	public String getStrategy() {
	
		return strategy;
	}
	
	public void setStrategy(String str) {
	
		strategy=str;
	} 
	
	public Iterator getHookInstances()  {
	
		return hookInstances.iterator();
	}
	
	public void addHookInstance(HookInstance init)  {
		hookInstances.add(init);
	}
	
	public void setImports(PImports p)  {
		importPackages=p;
	}
	
	public PImports getImports()  {
	
		return importPackages;
	}
	
	public HookInstance findInstanceForName(String name)  {
	
		Iterator i = getHookInstances();
		while (i.hasNext())  {
		
			HookInstance hi = (HookInstance) i.next();
			if(hi.getVarName().equals(name))
				return hi;
		}
		
		return null;
	}	
		
}
	