/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.util;

import java.io.File;
import java.net.URL;


public class DynamicClassLoader {
	
	private ClassLoader loader = ClassLoader.getSystemClassLoader();
	
	public void addLoadPath(File file) {
		
		URL  url=null;
		try{
		url = file.toURL();
		//System.out.println("registrring dynamic classpath: "+url);
		}
		catch(Exception ex) {System.err.println(ex);
		}
		URL[] urls = new URL[1];
		urls[0] = url;
		loader = new MyURLClassLoader(urls, loader);
	}
	
	public Class getClass(String name) throws ClassNotFoundException {
		
		//System.out.println("Loading class"+name);
		Class c =  loader.loadClass(name);
		//System.out.println("End Loading class"+name);
		//System.out.println("-----------------------------");
		
		return c;
	}
	
	public void clear()  {
		loader= ClassLoader.getSystemClassLoader();
	}
}

