package jasco.util;

import javassist.CtClass;
import javassist.CtMethod;
import javassist.bytecode.AnnotationsAttribute;
import javassist.bytecode.ClassFile;
import javassist.bytecode.MethodInfo;

public class JavassistHelper {

	public static boolean hasAnnotation(CtMethod method, Class annotation) {
		
		checkAnnotation(annotation);
		
		return hasAnnotation(method,annotation.getName());
	}
	
	public static boolean hasAnnotation(CtClass clz, Class annotation) {
		
		checkAnnotation(annotation);
		
		return hasAnnotation(clz,annotation.getName());
	}

	public static boolean hasAnnotation(CtMethod method, String name) {
		MethodInfo minfo = method.getMethodInfo();
		AnnotationsAttribute attr = (AnnotationsAttribute)
		minfo.getAttribute(AnnotationsAttribute.visibleTag);
		if (attr != null) {
		    javassist.bytecode.annotation.Annotation an = attr.getAnnotation(name);
		    return an!=null;
		}
		else return false;
	}
	
	public static boolean hasAnnotation(CtClass method, String name) {
		ClassFile minfo = method.getClassFile();
		AnnotationsAttribute attr = (AnnotationsAttribute)
		minfo.getAttribute(AnnotationsAttribute.visibleTag);
		if (attr != null) {
		    javassist.bytecode.annotation.Annotation an = attr.getAnnotation(name);
		    return an!=null;
		}
		else return false;
	}

	private static void checkAnnotation(Class annotation) {
		if(!annotation.isAnnotation())
			throw new IllegalArgumentException("supplied annotation is not of annotation type");
		
	}
}
