/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.util;

import gnu.regexp.RE;

public class RegexpMatcher  {

	public static boolean match(String regexp, String tomatch)  {
		
		try  {
		RE re = new RE(makeGNUReg(regexp));
		return match(re,tomatch);
		}catch(Exception ex)  {
			jasco.util.logging.Logger.getInstance().showFullError(ex);
		}
		return false;
	}
	
	public static boolean match(RE regexp, String tomatch)  {
	
			
		return regexp.isMatch(makeGNUReg(tomatch));
		
	}
	
	private RE regexp = null;
	
	public RegexpMatcher(String regexp)  {
		
		try {
		this.regexp=new RE(makeGNUReg(regexp));
		
		}catch(Exception ex)  {
			jasco.util.logging.Logger.getInstance().showFullError("Unable to init regexp: "+regexp);
		}
	}
	
	public boolean isMatch(String target)  {
		
		if(regexp==null)
			return false;
		else return match(regexp,target);
	}
	
	public static String makeGNUReg(String s)  {
		
		s=s.replace('.','');
		s=s.replace('/','');
		s=s.replace('[','');
		s=s.replace(']','');
		s=s.replace('(','');
		s=s.replace(')','');
		s=s.replace('$','');
		StringBuffer buffer = new StringBuffer(s);
		
		int k = s.indexOf("*");
		while (k!=-1)  {
			buffer.insert(k,'.');
			s=buffer.toString();
			k=s.indexOf("*",k+2);
		}
		return buffer.toString();
	}
}