package jasco.util.distribution;

import jasco.runtime.distribution.causality.LocalVectorClock;

import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;

import org.jgroups.protocols.TransportedVectorTime;

/**
 * @author scastro, lbenavid
 * 
 */
public class JascoInputStream extends ObjectInputStream {

	public JascoInputStream(InputStream in) throws IOException{
		super(new BufferedInputStream(in));

		try {
			RemoteInfo ri = (RemoteInfo)readObject();
			JascoThreadCflow.setRemoteInfo(ri);
			TransportedVectorTime tvc = (TransportedVectorTime) readObject();
			LocalVectorClock.getInstance().computeCausalLocalClock(tvc);
			System.out.println("ObjectInputStream: local vector clock " + tvc);
		} catch(ClassNotFoundException e) {
			e.printStackTrace();
		}
	}

}
