package jasco.util.distribution;

import jasco.runtime.distribution.DistributedOptions;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Proxy;
import java.net.Socket;
import java.net.SocketException;
import java.net.SocketImpl;
import java.net.UnknownHostException;

/**
 * @author scastro, lbenavid
 * 
 */
public class JascoSocket extends Socket {
    private OutputStream out = null;
    private InputStream in = null;
	
	
	public JascoSocket() {
		super();
	}

	public JascoSocket(Proxy proxy) {
		super(proxy);
	}

	public JascoSocket(SocketImpl impl) throws SocketException {
		super(impl);
	}

	public JascoSocket(String host, int port) throws UnknownHostException,
			IOException {
		super(host, port);
	}

	public JascoSocket(InetAddress address, int port) throws IOException {
		super(address, port);
	}

	public JascoSocket(String host, int port, InetAddress localAddr,
			int localPort) throws IOException {
		super(host, port, localAddr, localPort);
	}

	public JascoSocket(InetAddress address, int port, InetAddress localAddr,
			int localPort) throws IOException {
		super(address, port, localAddr, localPort);
	}

	public JascoSocket(String host, int port, boolean stream)
			throws IOException {
		super(host, port, stream);
	}

	public JascoSocket(InetAddress host, int port, boolean stream)
			throws IOException {
		super(host, port, stream);
	}
	
    public synchronized InputStream getInputStream() throws IOException {
    	if (in == null) {
    		if(getPort() == getExceptionPort())
    			in = super.getInputStream();
    		else
    			in = new JascoInputStream(super.getInputStream());
    	}
    	return in;
        }

        public synchronized OutputStream getOutputStream() throws IOException {	
    	if (out == null) {
    		if(getPort() == getExceptionPort())
    			out = super.getOutputStream();
    		else
    			out = new JascoOutputStream(super.getOutputStream());
    	}
    	return out;
        }

        private int getExceptionPort() {
        	return DistributedOptions.getInstance().getRMIExceptionPort();
        }

}



