package jasco.util.distribution;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author scastro
 * 
 */
public class RemoteInfo implements Serializable {

	private List<StackInfo> stacks;

	public RemoteInfo() {
		if(JascoThreadCflow.getRemoteInfo()!=null) {
			setStacks(JascoThreadCflow.getRemoteInfo().getStacks());
		}
		else {
			setStacks(new ArrayList<StackInfo>());
		}
		addStackInfo(new StackInfo());
	}
	
	public List<StackInfo> getStacks() {
		return stacks;
	}
	
	public void setStacks(List<StackInfo> stacks) {
		this.stacks = stacks;
	}
	
	public void addStackInfo(StackInfo stackInfo) {
		stacks.add(0, stackInfo);
	}
	
	public String[] getRemoteStack() {
		ArrayList<String> arrayList = new ArrayList<String>();
		for(StackInfo aStackInfo : stacks) {
			arrayList.addAll(Arrays.asList(aStackInfo.getStack()));
		}
		return arrayList.toArray(new String[0]);
	}
}

