/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
/*
 * Created on 26-nov-2004
 */
package jasco.util.javacompiler;

import jasco.options.Options;

import java.util.Iterator;
import java.util.Vector;

/**
 * @author Wim
 */
public class EclipseCompileErrorParser implements ICompileErrorParser {

	/**
	 * 
	 */
	public EclipseCompileErrorParser() {
		super();
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see jasco.util.javacompiler.ICompileErrorParser#parseErrors(java.util.Vector)
	 */
	
	public Vector parseWarnings(Vector errors) {
		
		return parse(errors,"WARNING");
	}
	
	public Vector parseErrors(Vector errors) {
		
		return parse(errors,"ERROR");
	}
	
	public Vector parse(Vector errors, String del) {
		Vector newErrors = new Vector();
		try {
		
		Iterator i = errors.iterator();
		parseUntillNextError(i);
		
		while(true) {
			String theError = "";
			if(!i.hasNext())
				break;
			String desc = (String) i.next(); //skip first dummy line
			if(desc.equals("----------"))
				continue;
			String res = parseUntillNextError(i);
			if(!i.hasNext())
				break;
			if(desc.indexOf(del)==-1)
				continue;
			int index = res.lastIndexOf(Options.NEWLINE);
			theError=res.substring(index+1)+Options.NEWLINE+res.substring(0,index)+Options.NEWLINE;
			
			newErrors.add(new CompileError(theError));
		}
	
		return newErrors;
		}
		catch(Exception t) {
			t.printStackTrace();
			System.err.println(t.getMessage());
		}
		
		return newErrors;
	}
	
	public String parseUntillNextError(Iterator i) {
		
		String res = "";
		while(i.hasNext()) {
			
			String s = i.next().toString();
			if(s.equals("----------"))
				return res;
			else {
				if(!res.equals(""))
					res+=Options.NEWLINE+s;
				else res+=s;
			}
		}
		return res;
	}
}
