/*
  Copyright (C) 2002-2005 JAsCo Development Team
  http://ssel.vub.ac.be/jasco

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as
  published by the Free Software Foundation; either version 2 of the
  License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA
 */
package jasco.util.logging;



public abstract class Logger  {
	
	private static Logger logger = new OutputLogger();
	
	protected Logger()  {
	}
	
	public static Logger getInstance()  {
	
		return logger;
	}
	
	public static void setInstance(Logger l)  {
	
		logger=l;
	}
	
	public void showDebug(String s)  {
		
		if(s==null)
			s="Null";
			
		if (jasco.options.Options.showDebugOutput())  {
			if(!s.startsWith("JASCO"))
				s="JASCO DEBUG:"+s;	
			showOutput(s);
		}
	}
	
	public void showDebug(Throwable ex)  {
		
		showDebug(ex.getMessage());
		ex.printStackTrace();
	}
	
	public abstract void showOutput(String output);
	public abstract void showOutputNoNewLine(String output);
	public abstract void showError(String error);
	public abstract void showError(Throwable ex);
	public abstract void showFullError(Throwable ex);
	public abstract void showFullError(String s);
	
	
	public void showError(jasco.util.javacompiler.CompileError error)  {
	
		showError(error.toString());
	}
	
	public void showWarning(String error)  {
	
		showOutput("JASCO WARNING:"+error);
	}
}