package test.stateful;

class StatefulControlFlow 
{
	hook TestHook 
	{
		TestHook(methodA(..args), methodB(..args), methodC(..args))
		{
			start > ATrans;
			ATrans: execution(methodA) > BTrans;
			BTrans: execution(methodB) > CTrans;
			CTrans: execution(methodC) > ATrans;
		}

		before ATrans()
		{
			System.out.println("Before Atrans: " + thisJoinPoint);
		}

		after ATrans() 
		{
			System.out.println("After Atrans: " + thisJoinPoint);
		}
		
		before BTrans()
		{
			System.out.println("Before Btrans: " + thisJoinPoint);
		}
		
		after BTrans() 
		{
			System.out.println("After Btrans: " + thisJoinPoint);
		}
		
		before CTrans()
		{
			System.out.println("Before Ctrans: " + thisJoinPoint);
		}
		
		after CTrans() 
		{
			System.out.println("After Ctrans: " + thisJoinPoint);
		}
	}
}
