package test;

import java.util.Hashtable;

public class PerTest {
	
	private static Thread f;
	
	private static Hashtable context1 = new Hashtable();
	private static Hashtable context2 = new Hashtable();
	private static Hashtable context3 = new Hashtable();
	
	
	public static void main(String[] args) throws Exception {
		
		//per object:
		System.out.println(" perobject :");
		final PerTest perTest1 = new PerTest();
		PerTest perTest2 = new PerTest();
		perTest1.perObjectTest();
		perTest2.perObjectTest();
		perTest1.perObjectTest();
		
		//per class:
		System.out.println(" perclass :");
		PerTest2 perTest3 = new PerTest2();
		perTest1.perClassTest();
		perTest3.perClassTest();
		perTest1.perClassTest();
		
		//per method:
		System.out.println(" permethod :");
		perTest1.perMethodTest();
		perTest1.perMethodTest2();
		perTest1.perMethodTest();
		
//		per thread:
		System.out.println(" perthread :");
		perTest1.perThreadTest();
		f = new Thread(new Runnable() {
			public void run() {
				System.out.println(Thread.currentThread());
				System.out.println(f);
				perTest1.perThreadTest();
				System.out.println(Thread.currentThread()==f);
			}
		});
		f.setName("boe");
		f.start();
		f.join();
		perTest1.perThreadTest();
		
		//per all:
		System.out.println(" perall :");
		perTest1.perAllTest();
		perTest1.perAllTest();
		
		System.out.println("THERESULT: "+getResult()); 
	}
	
	public void perObjectTest() {
			
	}
	
	public void perClassTest() {
			
	}
	
	public void perMethodTest() {}
	
	public void perMethodTest2() {}
	
	public void perAllTest() {}
	
	public void perThreadTest() {}
	
	public static void log(String content, int id) {
		
		if(context1.containsKey(content)&&context2.containsKey(content)) {
			context3.put(content,new Integer(id));
		}
		else if(context1.containsKey(content)) {
			context2.put(content,new Integer(id));
		}
		else {
			context1.put(content,new Integer(id));
		}
	}
	
	private static boolean getResult() {
		
		System.out.println(context1.toString());
		
		String[] tocheck = new String[] {"perobject","permethod","perclass","perthread","perall"};
		
		for(int i=0;i<tocheck.length;++i) {
			
			String content = tocheck[i];
			if(!context1.containsKey(content)&&!context2.containsKey(content)) 
				return false;
			
			Integer i1 = (Integer) context1.get(content);
			Integer i2 = (Integer) context2.get(content);
			
			System.out.println("ZZZZ:"+i1+";"+i2);
			
			if(i1.equals(i2))
				return false;
			
			if(context3.containsKey(content)) {
				Integer i3 = (Integer) context3.get(content);
				System.out.println("ZZZZ:"+i3);
				if(!i3.equals(i1))
					return false;
			}
		}
		
		return true;
	}

	
}

class PerTest2 {
	
	public void perClassTest() {
		
	}
}
	