/*
Based on code written by Michael Haupt <haupt@st.informatik.tu-darmstadt.de>
*/


package test.hello;

import jasco.runtime.connector.Connector;

public class HelloWorld {
  public static void main(String[] args) throws Throwable {
    // get hold of the connector
    Class connectorClass = Class.forName("Connector.HelloConnector");
    Connector c = (Connector) connectorClass.getDeclaredMethod(
        "getConnector", null
      ).invoke(null, null);
    System.out.println("Got a connector: " + c);
    
    if(args.length<1) {
    	System.err.println("argument expected");
    	return;
    }
    if(args[0].equalsIgnoreCase("static"))
    	runStaticTest(c);
    else if(args[0].equalsIgnoreCase("enabled"))
    	runEnabledTest(c);
    else System.err.println("Illegal argument: "+args[0]);
  }
  public static void runStaticTest(Connector c) {
	  
	  	c.setAdaptOnClasses(false);
	  // run
	    HelloWorld h = new HelloWorld();
	    HelloWorld h2 = new HelloWorld();
	    
	    System.out.println("should do nothing");
	    h.hello();
	    c.addInstance(h2);
	    System.out.println("should do something");
	    h2.hello(); 
	    
	    
  }
  
  public static void runEnabledTest(Connector c) {
	  HelloWorld h = new HelloWorld();
	    System.out.println("(connector enabled: " + c.isEnabled() + ")");
	    h.hello();
	    // switch off connector and re-run
	    c.setEnabled(false);
	    System.out.println("(connector enabled: " + c.isEnabled() + ")");
	    h.hello();
	    // switch back on and finish
	    c.setEnabled(true);
	    System.out.println("(connector enabled: " + c.isEnabled() + ")");
	    h.hello();
	    h.goodbye();
  }
  
  public void hello() {
    System.out.println("Hello, world!");
  }
  public void goodbye() {
    System.out.println("Good bye.");
  }
}
