package org.cachebench.tests;

import org.cachebench.tests.results.BaseTestResult;
import org.cachebench.reportgenerators.CsvSessionSimlatorReportGenerator;

/**
 * @author Mircea.Markus@jboss.com
 * @since 2.2
 */
public class SessionSimulatorTestResult extends BaseTestResult
{

   long readCount;
   long writeCount;
   long durration;
   long bytesRead;
   long bytesWritten;


   public SessionSimulatorTestResult(long readCount, long writeCount, long durration, long bytesRead, long bytesWritten)
   {
      this.readCount = readCount;
      this.writeCount = writeCount;
      this.durration = durration;
      this.bytesRead = bytesRead;
      this.bytesWritten = bytesWritten;
   }

   public long getTotalOperationCount()
   {
      return readCount + writeCount;
   }

   public long getReadCount()
   {
      return readCount;
   }

   public long getWriteCount()
   {
      return writeCount;
   }

   public double getNoRequestPerSec()
   {
      return getTotalOperationCount() / (durration / 1000.0);
   }

   public long getBytesRead()
   {
      return bytesRead;
   }

   public long getBytesWritten()
   {
      return bytesWritten;
   }

   public long getDurration()
   {
      return durration;
   }

   public String getReportGeneratorClassName()
   {
      return CsvSessionSimlatorReportGenerator.class.getName();
   }
}
