package org.cachebench.warmup;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.cachebench.CacheWrapper;

/**
 * Perfoms N puts, gets and removals, where n is configurable.
 *
 * @author Mircea.Markus@jboss.com
 * @since 2.2
 */
public class PutGetCacheWarmup extends CacheWarmup
{
   Log log = LogFactory.getLog(PutGetCacheWarmup.class);

   public void performWarmupOperations(CacheWrapper wrapper) throws Exception
   {
      Integer opCount = Integer.parseInt(getConfigParam("operationCount"));
      log.info("Cache launched, performing " + opCount + " put and get operations ");
      for (int i = 0; i < opCount; i++)
      {
         try
         {
            wrapper.put(String.valueOf(opCount), String.valueOf(opCount));
         } catch (Exception e)
         {
            log.warn("Exception on cache warmup", e);
         }
      }

      for (int i = 0; i < opCount; i++)
      {
         wrapper.get(String.valueOf(opCount));
      }
      log.trace("Cache warmup ended!");
   }
}
